<?php

require_once 'challengetwo_pair.php';

/*
  @param $name

    a string with arbitrary content

  @param $score

    a number or string containing a number

  @param $placeholder

    a string that will be inserted into the output string if $name and/or §score are empty.
    default [ '<unknown>' ]

  @return a string formated as

      "<name> [<score>]"

    if $name or $score are null or empty, then the placeholder '<unknown>' will
    be inserted. ie.

      "<unknown> [<score>]"
      "<name> [<unknown>]"
      "<unknown> [<unknown>]"
*/
function generateNameScoreStringOp(mixed $name, mixed $score, string $placeholder='<unknown>'): string {
  return ( strlen($name) == 0 ? $placeholder : $name ) . ' [' . ( strlen($score) == 0 ? $placeholder : $score ) . ']';
}

/*
  @param &$contactNameMapRef

    a map that contains keys that are identical to the ids stored in
    argument $idScorePairListRef. for each key a name is stored in map.

  @param &$idScorePairListRef

    a list that contains value pairs as elements:

      array(
        Pair("a", 1),
        Pair("b", 4),
        ...
      )

    the first value of each pair is a id that will be used as key in
    $contactNameMapRef in order to retrieve the value stored under that
    key/id.

  @param $callableGenerateStringOp

    a callable function that generates a string. function signature looks
    as follows

     function(string, string|number):string

   arguments will be a name-string that is stored in $contactNameMapRef and
   a score-number that is stored in $idScorePairListRef.

   by default $callableGenerateStringOp is null. in that case the default
   callable generateNameScoreStringOp() is being used.

  @return $outputList

    a list that contains strings generated by $callableGenerateStringOp.

    the order of strings corresponds to the order of entries in
    $idScorePairListRef.

  @todo a default callable can then be bound via FPT::curry()
*/
function generate_output_list(array &$contactNameMapRef, array &$idScorePairListRef, callable $callableGenerateStringOp = null ): array {
  static $outputList;
  $outputList = array();

  if ( $contactNameMapRef === null || $idScorePairListRef == null ) return $outputList;
  if ( $callableGenerateStringOp == null ) $callableGenerateStringOp = generateNameScoreStringOp(...);

  foreach ($idScorePairListRef as $pair) {
    if ( $pair === null ) continue;

    $id = $pair->first;
    if ( $id === null ) continue;

    $score = $pair->second;
    if ( $score === null ) continue;

    $name = $contactNameMapRef[$id];
    array_push($outputList, $callableGenerateStringOp($name, $score));
  }

  return $outputList;
}

?>
